
/*
#include <stdio.h>
#include <Arduino.h>
#include <EEPROM.h>
#include <SPI.h>
#include <avr/pgmspace.h>
*/
/*#include "FT_Platform.h"
#include "FT_Hal_SPI.cpp"
#include "FT_CoPro_Cmds.cpp"
#include "Swiss.cpp"*/

/* Sample application to demonstrat FT800 primitives, widgets and customized screen shots */
#include <Wire.h>
#include <string.h>
#include "FT_Platform.h"
#include "sdcard.h"
#include "FT_Hal_I2C.h"

#define SAMAPP_DELAY_BTW_APIS (1000)
#define SAMAPP_ENABLE_DELAY() Ft_Gpu_Hal_Sleep(SAMAPP_DELAY_BTW_APIS)
#define SAMAPP_ENABLE_DELAY_VALUE(x) Ft_Gpu_Hal_Sleep(x)

#define F16(s)        ((ft_int32_t)((s) * 65536))
#define SQ(v) (v*v)
#define WALL_BGTAG		(0x01)
#define CLOCK_BGTAG		(0x02)
#define CLOCK_MINTAG	        (0x03)
#define CALENDER            (0x04)
#define DATE_INCR            5
#define MONTH_INCR   6
#define YEAR_INCR    7
#define AM_PM        11
#define DATE_DEC    8
#define MONTH_DEC   9
#define YEAR_DEC    10

#define Clkoption	0
#define Clk_size	100
#define MAX_CLOCK_PROP (5)
#define AUDIO_SECTORS  4
#define AUDIO_RAM_SIZE  4096L
#define AUDIO_RAM_SPACE (AUDIO_RAM_SIZE-1)

/* Global variables for display resolution to support various display panels */
/* Default is WQVGA - 480x272 */
#ifdef SAMAPP_DISPLAY_WQVGA
ft_int16_t FT_DispWidth = 480;
ft_int16_t FT_DispHeight = 272;
ft_int16_t FT_DispHCycle =  548;
ft_int16_t FT_DispHOffset = 43;
ft_int16_t FT_DispHSync0 = 0;
ft_int16_t FT_DispHSync1 = 41;
ft_int16_t FT_DispVCycle = 292;
ft_int16_t FT_DispVOffset = 12;
ft_int16_t FT_DispVSync0 = 0;
ft_int16_t FT_DispVSync1 = 10;
ft_uint8_t FT_DispPCLK = 5;
ft_char8_t FT_DispSwizzle = 0;
ft_char8_t FT_DispPCLKPol = 1;
#else
ft_int16_t  FT_DispWidth = 320;
ft_int16_t  FT_DispHeight = 240;
ft_int16_t  FT_DispHCycle =  408;
ft_int16_t  FT_DispHOffset = 70;
ft_int16_t  FT_DispHSync0 = 0;
ft_int16_t  FT_DispHSync1 = 10;
ft_int16_t  FT_DispVCycle = 263;
ft_int16_t  FT_DispVOffset = 13;
ft_int16_t  FT_DispVSync0 = 0;
ft_int16_t  FT_DispVSync1 = 2;
ft_uint8_t  FT_DispPCLK = 8;
ft_char8_t  FT_DispSwizzle = 2;
ft_char8_t  FT_DispPCLKPol = 0;
#endif



/* Global used for buffer optimization */
Ft_Gpu_Hal_Context_t host,*phost;


ft_uint32_t Ft_CmdBuffer_Index;
ft_uint32_t Ft_DlBuffer_Index;

#ifdef BUFFER_OPTIMIZATION
ft_uint8_t  Ft_DlBuffer[FT_DL_SIZE];
ft_uint8_t  Ft_CmdBuffer[FT_CMD_FIFO_SIZE];
#endif

ft_void_t Ft_App_WrCoCmd_Buffer(Ft_Gpu_Hal_Context_t *phost,ft_uint32_t cmd)
{
#ifdef  BUFFER_OPTIMIZATION
  /* Copy the command instruction into buffer */
  ft_uint32_t *pBuffcmd;
  pBuffcmd =(ft_uint32_t*)&Ft_CmdBuffer[Ft_CmdBuffer_Index];
  *pBuffcmd = cmd;
#endif
#ifdef ARDUINO_PLATFORM
  Ft_Gpu_Hal_WrCmd32(phost,cmd);
#endif

  /* Increment the command index */
  Ft_CmdBuffer_Index += FT_CMD_SIZE;
}

ft_void_t Ft_App_WrDlCmd_Buffer(Ft_Gpu_Hal_Context_t *phost,ft_uint32_t cmd)
{
#ifdef BUFFER_OPTIMIZATION
  /* Copy the command instruction into buffer */
  ft_uint32_t *pBuffcmd;
  pBuffcmd =(ft_uint32_t*)&Ft_DlBuffer[Ft_DlBuffer_Index];
  *pBuffcmd = cmd;
#endif

#ifdef ARDUINO_PLATFORM
  Ft_Gpu_Hal_Wr32(phost,(RAM_DL+Ft_DlBuffer_Index),cmd);
#endif
  /* Increment the command index */
  Ft_DlBuffer_Index += FT_CMD_SIZE;
}

ft_void_t Ft_App_WrCoStr_Buffer(Ft_Gpu_Hal_Context_t *phost,const ft_char8_t *s)
{
#ifdef  BUFFER_OPTIMIZATION
  ft_uint16_t length = 0;
  length = strlen(s) + 1;//last for the null termination

  strcpy(&Ft_CmdBuffer[Ft_CmdBuffer_Index],s);

  /* increment the length and align it by 4 bytes */
  Ft_CmdBuffer_Index += ((length + 3) & ~3);
#endif
}

ft_void_t Ft_App_Flush_DL_Buffer(Ft_Gpu_Hal_Context_t *phost)
{
#ifdef  BUFFER_OPTIMIZATION
  if (Ft_DlBuffer_Index > 0)
    Ft_Gpu_Hal_WrMem(phost,RAM_DL,Ft_DlBuffer,Ft_DlBuffer_Index);
#endif
  Ft_DlBuffer_Index = 0;

}


ft_void_t Ft_App_Flush_Co_Buffer(Ft_Gpu_Hal_Context_t *phost)
{
#ifdef  BUFFER_OPTIMIZATION
  if (Ft_CmdBuffer_Index > 0)
    Ft_Gpu_Hal_WrCmdBuf(phost,Ft_CmdBuffer,Ft_CmdBuffer_Index);
#endif
  Ft_CmdBuffer_Index = 0;
}

#if 0
/* API to give fadeout effect by changing the display PWM from 100 till 0 */
ft_void_t SAMAPP_fadeout()
{
  ft_int32_t i;

  for (i = 100; i >= 0; i -= 3)
  {
    Ft_Gpu_Hal_Wr8(phost,REG_PWM_DUTY,i);

    Ft_Gpu_Hal_Sleep(2);//sleep for 2 ms
  }
}

/* API to perform display fadein effect by changing the display PWM from 0 till 100 and finally 128 */
ft_void_t SAMAPP_fadein()
{
  ft_int32_t i;

  for (i = 0; i <=100 ; i += 3)
  {
    Ft_Gpu_Hal_Wr8(phost,REG_PWM_DUTY,i);
    Ft_Gpu_Hal_Sleep(2);//sleep for 2 ms
  }
  /* Finally make the PWM 100% */
  i = 128;
  Ft_Gpu_Hal_Wr8(phost,REG_PWM_DUTY,i);
}

#endif

//=====================================================================================================================================================//
/* Optimized implementation of sin and cos table - precision is 16  */
FT_PROGMEM ft_prog_uint16_t sintab[] =
{
  0, 402, 804, 1206, 1607, 2009, 2410, 2811, 3211, 3611, 4011, 4409, 4807, 5205, 5601, 5997, 6392,
  6786, 7179, 7571, 7961, 8351, 8739, 9126, 9511, 9895, 10278, 10659, 11038, 11416, 11792, 12166, 12539,
  12909, 13278, 13645, 14009, 14372, 14732, 15090, 15446, 15799, 16150, 16499, 16845, 17189, 17530, 17868,
  18204, 18537, 18867, 19194, 19519, 19840, 20159, 20474, 20787, 21096, 21402, 21705, 22004, 22301, 22594,
  22883, 23169, 23452, 23731, 24006, 24278, 24546, 24811, 25072, 25329, 25582, 25831, 26077, 26318, 26556, 26789,
  27019, 27244, 27466, 27683, 27896, 28105, 28309, 28510, 28706, 28897, 29085, 29268, 29446, 29621, 29790, 29955,
  30116, 30272, 30424, 30571, 30713, 30851, 30984, 31113, 31236, 31356, 31470, 31580, 31684, 31785, 31880, 31970,
  32056, 32137, 32213, 32284, 32350, 32412, 32468, 32520, 32567, 32609, 32646, 32678, 32705, 32727, 32744, 32757,
  32764, 32767, 32764
};






ft_int16_t qsin(ft_uint16_t a)
{
  ft_uint8_t f;
  ft_int16_t s0,s1;

  if (a & 32768)
    return -qsin(a & 32767);
  if (a & 16384)
    a = 32768 - a;
  f = a & 127;
  s0 = ft_pgm_read_word(sintab + (a >> 7));
  s1 = ft_pgm_read_word(sintab + (a >> 7) + 1);
  return (s0 + ((ft_int32_t)f * (s1 - s0) >> 7));
}

/* cos funtion */
ft_int16_t qcos(ft_uint16_t a)
{
  return (qsin(a + 16384));
}

/* API to check the status of previous DLSWAP and perform DLSWAP of new DL */
/* Check for the status of previous DLSWAP and if still not done wait for few ms and check again */
ft_void_t Ft_Gpu_DLSwap(ft_uint8_t DL_Swap_Type)
{
  ft_uint8_t Swap_Type = DLSWAP_FRAME,Swap_Done = DLSWAP_FRAME;

  if(DL_Swap_Type == DLSWAP_LINE)
  {
    Swap_Type = DLSWAP_LINE;
  }

  /* Perform a new DL swap */
  Ft_Gpu_Hal_Wr8(phost,REG_DLSWAP,Swap_Type);

  /* Wait till the swap is done */
  while(Swap_Done)
  {
    Swap_Done = Ft_Gpu_Hal_Rd8(phost,REG_DLSWAP);
    if(DLSWAP_DONE != Swap_Done)
    {
      Ft_Gpu_Hal_Sleep(10);//wait for 10ms
    }
  }
}



/*****************************************************************************/
/* Example code to display few points at various offsets with various colors */



/* Boot up for FT800 followed by graphics primitive sample cases */
/* Initial boot up DL - make the back ground green color */
const ft_uint8_t FT_DLCODE_BOOTUP[12] =
{
  255,255,255,2,//GPU instruction CLEAR_COLOR_RGB
  7,0,0,38, //GPU instruction CLEAR
  0,0,0,0,  //GPU instruction DISPLAY
};


//====================================Clock Skin properties =================

FT_PROGMEM ft_uint8_t clk_prp[] = {/*bgcolor*/255,255,255,255,/*Mincolor*/0,0,0,255,/*SecsColor*/255,41,43,255,
                                /*bgcolor*/255,255,255,255,/*Mincolor*/255,0,0,255,/*SecsColor*/255,41,43,255,
                                /*bgcolor*/24,24,22,255,   /*Mincolor*/255,255,255,255,/*SecsColor*/255,41,43,255,
                                /*bgcolor*/206,177,8,255,  /*Mincolor*/0,0,0,255,/*SecsColor*/0,0,0,255,
                                /*bgcolor*/206,177,8,255,  /*Mincolor*/204,30,26,255,/*SecsColor*/0,0,0,255,
                                /*bgcolor*/255,255,255,255,/*Mincolor*/204,30,26,255,/*SecsColor*/0,0,0,255};

//====================================Background image properties =================
typedef struct
{
    char name[11];
    ft_uint16_t imw;
    ft_uint16_t imh;
    ft_uint16_t clk_orgin_x;
    ft_uint16_t clk_orgin_y;
    ft_uint16_t clk_size;

}t_imageprp;

t_imageprp image_prp[10] = {
                    // file name	imw		imh		xyoffset	// clksize
                                        {"",      		284L,	177L,	142,88,		80},
                                        {"",      		284L,	177L,	142,88,		80},
                                        {"bgimg7.jpg",		284L,	177L,	142,88,		80},
                    {"bgimg0.jpg",		320l,	200l,	100,86,			96},
                    {"bgimg1.jpg",		295l,	200l,	198,29,			16},
                    {"bgimg2.jpg",		320l,	200l,	222,132,		60},
                    {"bgimg3.jpg",		261l,	200l,	203,55,			40},
                    {"bgimg4.jpg",		320l,	200l,	192,120,		70},
                    {"bgimg8.jpg",		275l,	183l,	175,48,		21},
                    {"bgimg9.jpg",		187l,	200l,	87,97,		57},
                    };

//===============================global flags and variables========================

struct
{
    ft_uint8_t Hrs;
    ft_uint8_t Mins;
    ft_uint8_t Secs;
        ft_uint8_t date;
        ft_uint8_t month;
        ft_uint8_t year;
    ft_uint16_t mSecs;
}Rtc;

typedef struct
{
    ft_uint8_t Touch_detect:1;
    ft_uint8_t img_change:1;
    ft_uint8_t Image_loaded:1;
        ft_uint8_t Load_image:1;
    ft_uint8_t fifo_busy:1;
    ft_uint8_t time_alert:1;
        ft_uint8_t rotary:1;
        ft_uint8_t clk_adj:1;
        ft_uint8_t audio_play:1;
        ft_uint8_t audio_load:1;
        ft_uint8_t date_set:1;
        ft_uint8_t am_pm:1;
}bitfield;

bitfield Flag;



static ft_int32_t fsize = 0;
static ft_uint8_t wall_bg = 0;
static ft_uint8_t sd_present =0;
Reader imfile,adfile;
ft_uint8_t temp_time[7]/*,buff[512]*/;


FT_PROGMEM const char *info[] = {  "FT800 FTClock Application",
                  	"APP to demonstrate interactive Clock,",
                  	"using Lines,Points,Jpeg decode",
                  	"& RTC control."
                     }; 

FT_PROGMEM ft_prog_uchar8_t arrow[] = {0x78,0x9C,0xBD,0xD0,0xA9,0x11,0x00,0x30,0x0C,0x04,0x31,0xF7,0x5F,0xAD,0x3B,0xD8,0x70,0xCD,0x24,0x30,0xC7,0x2C,0xE0,0x6F,0xE6,0x7B,0x96,0x3A,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xE0,0x52,0xEF,0xB3,0x1F,0xF3,0xD8,0x87,0x7D,0xB9,0x87,0x7B,0xFD,0xC7,0xD7,0x1C,0x6F,0x57,0x58,0x99};
FT_PROGMEM ft_prog_uchar8_t arrow1[] = {0x78,0x9C,0xDD,0xD2,0x4F,0x0E,0xC1,0x50,0x10,0x06,0xF0,0x47,0x68,0x48,0x69,0xDD,0x80,0x1B,0xF4,0x08,0xDC,0xA0,0x6E,0xA0,0x07,0x91,0x70,0x03,0x6E,0xE0,0x08,0xEC,0x6D,0xEC,0xAC,0x24,0x0E,0x20,0xE1,0x06,0x28,0xE2,0x4F,0x52,0xA3,0xF3,0xDE,0x1B,0x33,0x2F,0x6C,0x6D,0x7C,0xBB,0xDF,0xA6,0xDF,0xBC,0xE9,0x28,0xF5,0x9B,0xCC,0x5C,0xD6,0xCE,0xAE,0x23,0x70,0xBD,0x87,0x44,0xD2,0x03,0x38,0x48,0x87,0x00,0x57,0xE9,0x09,0x00,0x34,0x84,0x73,0x82,0x68,0xAC,0xA3,0x8F,0xEC,0x36,0x3A,0x93,0x6D,0x98,0x2E,0xB1,0xA2,0xC9,0x8D,0xA1,0xF1,0x8D,0x3C,0x35,0xA6,0x91,0x8B,0x96,0x30,0x36,0x0E,0xC8,0xA9,0x71,0x4C,0xCE,0x78,0x38,0x93,0x0E,0xB2,0xCA,0xDE,0x89,0x36,0xCC,0x05,0xDD,0x9F,0xBF,0xB3,0x52,0x7F,0x90,0x0D,0xBF,0x67,0x89,0xEE,0xF1,0x7B,0xF5,0xC6,0x03,0xB6,0x5E,0x68,0x89,0x6D,0x3E,0xB0,0x25,0xDA,0x1B,0x8A,0x9C,0xF5,0x89,0x85,0xB6,0x6C,0xA3,0xE5,0x83,0x26,0x18,0x7D,0xFF,0xBF,0x43,0x72,0x59,0xF3,0xC9,0x23,0xEB,0xC6,0x13,0xBB,0x89,0x5E,0xB3,0x7D,0x71,0x0D,0x98,0x42,0xCE,0xBB,0x7C,0xF3,0xE0,0xF3,0x7E,0x13,0x69,0x4F,0xB6,0xE9,0x91,0x53,0xD7,0xF1,0xC2,0xB5,0xAF,0x7E,0x94,0x17,0x03,0x64,0xFA,0x39};
                                   //===================================Blend Funtions===========================

void Ft_CMask_RGB()
{
  Ft_Gpu_Hal_Transfer32(phost,COLOR_MASK(1, 1, 1, 0));
}
/* words generated - 1 */

void Ft_CMask_A()
{
  Ft_Gpu_Hal_Transfer32(phost,COLOR_MASK(0, 0, 0, 1));
}

void Ft_CMask_RGBA()
{
  Ft_Gpu_Hal_Transfer32(phost,COLOR_MASK(1, 1, 1, 1));
}
/* words generated - 2 */
void Ft_Paint_A()
{
  Ft_CMask_A();
  Ft_Gpu_Hal_Transfer32(phost,BLEND_FUNC(ONE, ZERO));
}
/* words generated - 2 */
void Ft_Clear_A()
{
  Ft_CMask_A();
  Ft_Gpu_Hal_Transfer32(phost,BLEND_FUNC(ZERO, ONE_MINUS_SRC_ALPHA));
}
/* words generated are - 2*/

void Ft_Mask_A()
{
  Ft_CMask_A();
  Ft_Gpu_Hal_Transfer32(phost,BLEND_FUNC(DST_ALPHA, ZERO));
}
/* words generated - 2 */

void Ft_Use_A()
{
    Ft_CMask_RGB();
    Ft_Gpu_Hal_Transfer32(phost,BLEND_FUNC(DST_ALPHA, ONE_MINUS_DST_ALPHA));
}
/* words generated - 2 */

void Ft_No_A()
{
  Ft_CMask_RGBA();
  Ft_Gpu_Hal_Transfer32(phost,BLEND_FUNC(SRC_ALPHA, ONE_MINUS_SRC_ALPHA));
}


static void polarxy(ft_int32_t r, float th, ft_int16_t *x, ft_int16_t *y,ft_uint16_t ox,ft_uint16_t oy)
{
  th = (th * 182.044);
  *x = (16 * ox + (((long)r * qsin(th)) >> 11) + 16);
  *y = (16 * oy - (((long)r * qcos(th)) >> 11));
}


static void polar(ft_int32_t r, float th,ft_uint16_t ox,ft_uint16_t oy)
{
  ft_int32_t x, y;
  th = (th * 182.044);
  x = (16 * ox + (((long)r * qsin(th)) >> 11) + 16);
  y = (16 * oy - (((long)r * qcos(th)) >> 11));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(x,y));
}

//======================================Audio intialization==========================


// Sampling frequency 16Khz
// RAM Starting location 0
// Length 4kb
// Format ULAW SAMPLES

void Init_Audio()
{
  Ft_Gpu_Hal_Wr32(phost,REG_PLAYBACK_FREQ,16000);
  Ft_Gpu_Hal_Wr32(phost,REG_PLAYBACK_START,0);
  Ft_Gpu_Hal_Wr8(phost,REG_PLAYBACK_FORMAT,ULAW_SAMPLES);
  Ft_Gpu_Hal_Wr32(phost,REG_PLAYBACK_LENGTH,4096);
  Ft_Gpu_Hal_Wr8(phost,REG_PLAYBACK_LOOP,1);
}

//====================================================================================

//For clean minleg hr leg

float mag(ft_int32_t vx, ft_int32_t vy)
{
    return sqrt(vx*vx + vy*vy);
}


void Vc1_Cleanline(ft_int32_t w,ft_int16_t x0,ft_int16_t y0,ft_int16_t x1,ft_int16_t y1)
{
  ft_int32_t dx,dy,cx,cy;
  float m,scale;
  Ft_Gpu_Hal_Transfer32(phost,BEGIN(LINES));
  Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH((ft_int32_t)(w)));
  Ft_Paint_A();
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(x0, y0));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(x1, y1));
  dx = (x1 - x0);
  dy = (y1 - y0);
  m = mag(dx, dy);
  scale = w / m;
  dx = (ft_int32_t)(dx * scale);
  dy = (ft_int32_t)(dy * scale);
  cx = dy;
  cy = -dx;
  Ft_Clear_A();

  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(x0 - dx + cx, y0 - dy + cy));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(x0 - dx - cx, y0 - dy - cy));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(x1 + dx + cx, y1 + dy + cy));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(x1 + dx - cx, y1 + dy - cy));
  Ft_Use_A();
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(x0, y0));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(x1, y1));
  Ft_No_A();
}


//=====================================================Draw the Clock ==============================================================
void Draw_Clock(ft_int16_t Ox,ft_int16_t Oy,ft_uint16_t Clock_Size,ft_uint32_t bgcolor,ft_uint32_t tickcolor,ft_uint32_t seccolor)
{
  ft_int16_t x0,y0,x1,y1,z;
  float th;


 /* Clock skin color */
  Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB((bgcolor>>16)&0xff,(bgcolor>>8)&0xff,(bgcolor>>0)&0xff));
 /* Clock Size*/
  Ft_Gpu_Hal_Transfer32(phost,POINT_SIZE(Clock_Size*16));
  Ft_Gpu_Hal_Transfer32(phost,BEGIN(FTPOINTS));
 /* Allow to Update the Tag buffer */
  Ft_Gpu_Hal_Transfer32(phost,TAG_MASK(1));
 /* Assign the Tag Value for Clock*/
  Ft_Gpu_Hal_Transfer32(phost,TAG(CLOCK_BGTAG));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((Ox)*16,Oy*16));    // locate
 /* Clock Tick color*/
  Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB((tickcolor>>16)&0xff,(tickcolor>>8)&0xff,(tickcolor>>0)&0xff));
 /*Set the Legsize based on the Clock Size*/
  Ft_Gpu_Hal_Transfer32(phost,BEGIN(LINES));
  Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH((ft_int32_t)(0.00790 * Clock_Size * 16)));							// .00975 for tick size adj
 /*place the Minute ticks, angle difference is 6 degree*/
  for(z=0;z<60;z++)
  {
      if((z%5)!=0)
      {
        polar((ft_int32_t)(0.950*Clock_Size),z*6,Ox,Oy);
        polar((ft_int32_t)(0.850*Clock_Size),z*6,Ox,Oy);
      }  
  }
 /*Set the Ticksize based on the Clock Size*/
  Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH((ft_int32_t)(0.037 * Clock_Size * 16)));							// .037 for tick size adj
 /*Place the 5 min ticks 5*6=30 degree*/
  for(z=0;z<12;z++)
  {
    polar((ft_int32_t)(0.946*Clock_Size),z*30,Ox,Oy);
    polar((ft_int32_t)(0.450*Clock_Size),z*30,Ox,Oy);
  }

  /* Remove the curvature */
  Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB((bgcolor>>16)&0xff,(bgcolor>>8)&0xff,(bgcolor>>0)&0xff));			// backround color
  Ft_Gpu_Hal_Transfer32(phost,BEGIN(FTPOINTS));
  Ft_Paint_A();
  Ft_Gpu_Hal_Transfer32(phost,POINT_SIZE(16*Clock_Size));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(Ox*16,Oy*16));
  Ft_Clear_A();
  Ft_Gpu_Hal_Transfer32(phost,POINT_SIZE((ft_int32_t)(0.946*Clock_Size)*16));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(Ox*16,Oy*16));
  Ft_Use_A();
  Ft_Gpu_Hal_Transfer32(phost,POINT_SIZE(16*Clock_Size));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(Ox*16,Oy*16));
  Ft_No_A();
  /* Point for inner curvature*/
  Ft_Gpu_Hal_Transfer32(phost,POINT_SIZE((ft_int32_t)(0.700*Clock_Size)*16));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((Ox)*16,Oy*16));

  Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB((tickcolor>>16)&0xff,(tickcolor>>8)&0xff,(tickcolor>>0)&0xff));			// backround color

 // hrs
  th = (Rtc.Hrs*30) + (Rtc.Mins * 0.5);
  polarxy((ft_int32_t)(0.400*Clock_Size),th+0,&x0,&y0,Ox,Oy);
  polarxy((ft_int32_t)(0.200*Clock_Size),th+180,&x1,&y1,Ox,Oy);
  Vc1_Cleanline((ft_int32_t)(0.037 * Clock_Size * 16),x0,y0,x1,y1);
// minutes

  th = (Rtc.Mins*6) + (Rtc.Secs * 0.1);
  Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH((ft_int32_t)(0.18 * Clock_Size * 16)));
  Ft_Gpu_Hal_Transfer32(phost,COLOR_MASK(0,0,0,0));
  Ft_Gpu_Hal_Transfer32(phost,TAG(CLOCK_MINTAG));
  polar((ft_int32_t)(0.500*Clock_Size),th+0,Ox,Oy);
  polar((ft_int32_t)(0.100*Clock_Size),th+180,Ox,Oy);
  Ft_Gpu_Hal_Transfer32(phost,COLOR_MASK(1,1,1,1));

  polarxy((ft_int32_t)(0.750*Clock_Size),th+0,&x0,&y0,Ox,Oy);
  polarxy((ft_int32_t)(0.200*Clock_Size),th+180,&x1,&y1,Ox,Oy);
  Vc1_Cleanline((ft_int32_t)(0.037 * Clock_Size * 16),x0,y0,x1,y1);
  Ft_Gpu_Hal_Transfer32(phost,TAG_MASK(0));

// secs
  Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB((seccolor>>16)&0xff,(seccolor>>8)&0xff,(seccolor>>0)&0xff));			// backround color
  Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH((ft_int32_t)(0.014 * Clock_Size * 16)));
  th =  Rtc.mSecs*0.006+Rtc.Secs*6;
  polar((ft_int32_t)(0.650*Clock_Size),th,Ox,Oy);
  polar((ft_int32_t)(0.300*Clock_Size),th+180,Ox,Oy);

// Center point and secs needle point
  Ft_Gpu_Hal_Transfer32(phost,BEGIN(FTPOINTS));
  Ft_Gpu_Hal_Transfer32(phost,POINT_SIZE((ft_int32_t)(0.070 * Clock_Size * 16)));
  polar((ft_int32_t)(0.450*Clock_Size),th,Ox,Oy);

  Ft_Gpu_Hal_Transfer32(phost,POINT_SIZE((ft_int32_t)(0.050 * Clock_Size * 16)));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((Ox)*16,Oy*16));
}

//=============================Load Jpeg ===============================================


ft_void_t Load_Jpeg()
{
  ft_uint8_t ibuff[512L];
  static byte jpegstfail = 0;
  if(jpegstfail==1)
  {
     if(Ft_Gpu_Hal_WaitCmdfifo_empty_status(phost)==0)
     {
        jpegstfail = 1;
          return;   
     }
     else
     {
       jpegstfail = 0;
     }
  }
  for(byte z=0;z<4;z++)
  {
    if(fsize > 0)
    {
      uint16_t n = fsize > 512L ? 512L :fsize;
      n = (n + 3) & ~3;      
      imfile.readsector(ibuff);
      
      Ft_Gpu_Hal_WrCmdBuf_nowait(phost,ibuff,n);				/* copy data continuously into command memory */
      fsize -= n;
      if(fsize<=0)
      {
          Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
          Flag.Image_loaded = 1;
          Flag.fifo_busy = 0;
          jpegstfail = 0;
          return;
       } 
      if(Ft_Gpu_Hal_WaitCmdfifo_empty_status(phost)==0)
      {
        jpegstfail = 1;
        return;   
      }  
    }
  }
}

//=========================Intiate the properties of the jpeg===============================
ft_void_t Load_wallbg(ft_uint8_t bmphandle)
{
  byte file;
  if(wall_bg==0 || wall_bg==1)
  {
    Flag.fifo_busy = 0;
    Flag.Image_loaded =1;
  }
  else
  {
    fsize = 0;
    file = imfile.openfile(image_prp[wall_bg].name);
    fsize = imfile.size;
    Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(bmphandle));
    Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(bmphandle?134144L:6144L));
    Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(RGB565,image_prp[wall_bg].imw*2,image_prp[wall_bg].imh));
    Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST,BORDER,BORDER,image_prp[wall_bg].imw,image_prp[wall_bg].imh));
    Ft_Gpu_Hal_WrCmd32(phost,CMD_LOADIMAGE);
    Ft_Gpu_Hal_WrCmd32(phost,bmphandle?134144L:6144L);
    Ft_Gpu_Hal_WrCmd32(phost,0);
  }
  if(wall_bg<9)	wall_bg++; else wall_bg=0;
}
//======================Load alert audio ======================================================
void Load_afile(ft_uint32_t add, Reader &r,ft_uint8_t noofsectors)
{
  ft_uint8_t tbuff[512],z;
  ft_uint16_t temp_add = 0;

  for(z=0;z<noofsectors;z++)
  {
    r.readsector(tbuff);
    temp_add = (add+(512L*z))&AUDIO_RAM_SPACE;
    Ft_Gpu_Hal_WrMem(phost,temp_add,tbuff,512L);
  }
}
//====================== volume,play/stop ========================================================
void Playback(ft_uint8_t play,ft_uint8_t vol)
{
  Ft_Gpu_Hal_Wr8(phost,REG_PLAYBACK_PLAY,play);
  Ft_Gpu_Hal_Wr8(phost,REG_VOL_PB,vol);
}

// =========================Play sound===========================================================
void Ft_Play_Sound(ft_uint8_t sound,ft_uint8_t vol,ft_uint8_t midi)
{
  ft_uint16_t val = (midi << 8) | sound;
  Ft_Gpu_Hal_Wr8(phost,REG_SOUND,val);
  Ft_Gpu_Hal_Wr8(phost,REG_PLAY,1);
}

//==========================Compute the time from the rotary ============================================

static ft_uint16_t Get_TagRotary_Value(ft_uint16_t Tagval,ft_uint16_t range,ft_uint16_t max_rotation,ft_uint16_t ct)		// -180 for 90
{
  ft_int32_t trackval = 0;
  static ft_int16_t thcurr=0,prevth=0,adj=0;
  static ft_int32_t adj_val= 0;
  static ft_uint16_t retval=0;
  trackval = Ft_Gpu_Hal_Rd32(phost,REG_TRACKER);
  if(trackval)
  {
    thcurr = (trackval >> 16);
    if(adj == Tagval)
    {
        Flag.rotary = 1;
    adj_val += (ft_int16_t)(thcurr - prevth);
    if (adj_val < 0)
    adj_val += (max_rotation*65536L);
    if (adj_val >= (max_rotation*65536L))
    adj_val -= (max_rotation*65536L);
        retval = (adj_val/(65536L/range));
    }
    prevth = thcurr;
    adj = trackval & 0xff;
    Flag.clk_adj = 0;
  }
  else
  {
    if(adj==Tagval)
    Flag.clk_adj = 1;    else
    retval = ct;
    adj_val=  ((ct/60)*65536L)+((ct%60)*(65536L/range));         // convert the current time into rotary counts
    adj = 0;
    Flag.rotary = 0;
  }
  return retval;
}


//===============================================time alert =====================================================================


void alert()
{
  char hrs_in[13][8] = {"12.ULW","1.ULW","2.ULW","3.ULW","4.ULW","5.ULW","6.ULW","7.ULW","8.ULW","9.ULW","10.ULW","11.ULW","12.ULW"};
  static ft_int16_t  wp=0;

  static ft_int32_t size;
  static ft_int32_t rp,val,n;

  if(Flag.Touch_detect == 0 && Flag.fifo_busy == 0)
  {
  
  
        byte file = adfile.openfile((hrs_in[Rtc.Hrs]));
        if(file==0){Flag.time_alert=0;  return;}
        Flag.fifo_busy = 1;
        size = adfile.size;

        Load_afile(0,adfile,AUDIO_SECTORS);
       
        wp=(AUDIO_SECTORS*512L);
        Playback(1,50);
        Flag.audio_play  = 1;
    return;
  }
  if(Flag.audio_play)
  {
    if(size>0)
    {
      rp = Ft_Gpu_Hal_Rd32(phost,REG_PLAYBACK_READPTR);
      val = AUDIO_RAM_SPACE & (rp-wp);
      if (val > (AUDIO_SECTORS*512L))
      {
        n = min(AUDIO_SECTORS*512L,size);
        Load_afile(wp,adfile,AUDIO_SECTORS);
        wp = (wp +(n)) & AUDIO_RAM_SPACE;
        size-=n;
      }
      if(size<=0)
      {
          Playback(0,0);
          Flag.audio_play = 0;
          Flag.fifo_busy = 0;
          Flag.time_alert = 0;
      }
    }
  }
}
//================================Dec to binary and binary to dec =========================================
byte decToBcd(byte val)
{
  return ( (val/10*16) + (val%10) );
}

byte bcdToDec(byte val)
{
  return ( (val/16*10) + (val%16) );
}

//=========================== Read/ Write RTC =============================================================

void Rtc_puts()
{
  temp_time[0] = 0x80 | decToBcd(Rtc.Secs);
  Rtc.Hrs &= 0x1f;
  temp_time[2] = decToBcd(Rtc.Hrs)|0x60;
  if(Flag.am_pm==0)                // am
  {
    temp_time[2] = decToBcd(Rtc.Hrs)|0x40;
  }
  temp_time[1] = decToBcd(Rtc.Mins);
  temp_time[4] = decToBcd(Rtc.date);
  temp_time[5] = decToBcd(Rtc.month);
  temp_time[6] = decToBcd(Rtc.year);
  hal_rtc_i2c_write(0,(ft_uint8_t*)&temp_time,7);
}

// Gets the date and time from the ds1307
void Rtc_gets()
{
  hal_rtc_i2c_read(0,(ft_uint8_t*)&temp_time,7);
  Flag.am_pm = ((temp_time[2])>>5)&0x01;
  Rtc.Hrs = bcdToDec((temp_time[2] & 0x1f));
  Rtc.Mins = bcdToDec((temp_time[1] & 0x7f));
  Rtc.Secs = bcdToDec((temp_time[0] & 0x7f));
  Rtc.date =  bcdToDec((temp_time[4]&0x3f));
  Rtc.month =   bcdToDec((temp_time[5]&0x1f));
  Rtc.year =   bcdToDec((temp_time[6]&0xff));
}


//=============================Time adj ====================================================================

void timer()
{
  static ft_uint8_t temp_time = 1,temp_secs=0;
  static ft_uint16_t min_val,temp_m=0;
  static ft_uint16_t temp_msecs=0;
  static ft_int16_t adj_time = 0;
  static ft_uint32_t t_adj=0;
  ft_uint32_t t;
  #ifdef RTC_PRESENT
  Rtc_gets();
  temp_m =  ((Rtc.Mins)+(Rtc.Hrs*60))%720L;
  #else
  t = millis();
  Rtc.mSecs = t%1000L;
  Rtc.Secs = (t/1000L)%60;
  t -= t_adj;
  Rtc.Mins = (t/60000L)%60;
  Rtc.Hrs = (t/3600000L)%12;  
  temp_m =  ((Rtc.Mins)+(Rtc.Hrs*60));
  temp_m = temp_m + adj_time; 
  temp_m%=720;
  #endif
  
 // During date setting
  if(Flag.date_set==0)
  min_val = Get_TagRotary_Value(CLOCK_MINTAG,60,12,temp_m);
  else  min_val = temp_m;
  
  Rtc.Hrs = (min_val/60)%12;
  Rtc.Mins = (min_val)%60;
  
  
 //=============================================================
 /* time sync with mcu and rtc*/
  #ifdef RTC_PRESENT
  t = millis(); 
  t = t%1000L;
  if(Rtc.Secs!=temp_secs)
  {
    temp_secs = Rtc.Secs;
    temp_msecs = 1000L-t;
  } 
  Rtc.mSecs = (t+temp_msecs)%1000L;
  #endif
  
 //=============================================================
  if(Flag.clk_adj)
  {
    Flag.clk_adj = 0;
    #ifdef RTC_PRESENT
    Rtc_puts();
    #else
    t_adj = millis();
    t_adj = (t_adj/60000L)%60;
    adj_time = ((Rtc.Mins)+(Rtc.Hrs*60))-t_adj;
    #endif
  }
  if(Rtc.Hrs!=temp_time)
  {
    temp_time = Rtc.Hrs;
    Flag.time_alert  = 1;
  }
}

//==================Information Screen ========================
static ft_uint8_t sk=0;
ft_uint8_t Read_keys()
{
  static ft_uint8_t Read_tag=0,temp_tag=0,ret_tag=0;	
  Read_tag = Ft_Gpu_Hal_Rd8(phost,REG_TOUCH_TAG);
  ret_tag = NULL;
  if(Read_tag!=NULL && temp_tag!=Read_tag)
  {
     temp_tag = Read_tag;											// Load the Read tag to temp variable	
     sk = Read_tag;			
  } 
  if(Read_tag==NULL)
  {
     ret_tag =  temp_tag;
     temp_tag = 0;
     sk = 0;
  }
  return ret_tag;
}
//==============================================Information Screen =======================================
#define MEMCMD(a) Ft_Gpu_Hal_WrCmdBufFromFlash(phost,(ft_prog_uchar8_t*)(a), sizeof(a))

void play_setup()
{
  Ft_Gpu_Hal_WrCmd32(phost,CMD_INFLATE);
  Ft_Gpu_Hal_WrCmd32(phost,250*1024L);
  Ft_Gpu_Hal_WrCmdBufFromFlash(phost,arrow,sizeof(arrow1));
   static PROGMEM prog_uint32_t std[] = {
     CMD_DLSTART,
     BITMAP_HANDLE(14),
     BITMAP_SOURCE(250*1024L),
     BITMAP_LAYOUT(L4, 16, 32),
     BITMAP_SIZE(NEAREST, BORDER, BORDER, 32, 32  ),
     DISPLAY(),
   };MEMCMD(std);
  Ft_Gpu_CoCmd_Swap(phost);
  Ft_App_Flush_Co_Buffer(phost);
  Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
}

void incdec_setup()
{
  Ft_Gpu_Hal_WrCmd32(phost,CMD_INFLATE);
  Ft_Gpu_Hal_WrCmd32(phost,4585L);
  Ft_Gpu_Hal_WrCmdBufFromFlash(phost,arrow1,sizeof(arrow1)); 
  Ft_DlBuffer_Index = 0;
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(13));    // handle for background stars
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(4585L));      // Starting address in gram
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(L4, 32, 16));  // format 
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST, BORDER, BORDER, 32, 16  ));
  Ft_App_WrDlCmd_Buffer(phost,DISPLAY());
  Ft_App_Flush_DL_Buffer(phost);
  Ft_Gpu_DLSwap(DLSWAP_FRAME);
}


ft_void_t Info()
{
  ft_uint16_t dloffset = 0,z;
  Ft_CmdBuffer_Index = 0;
  // Touch screen Calibration
  Ft_Gpu_CoCmd_Dlstart(phost); 
  Ft_App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
  Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
  Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,FT_DispHeight/2,26,OPT_CENTERX|OPT_CENTERY,"Please tap on a dot");
  Ft_Gpu_CoCmd_Calibrate(phost,0);
  Ft_App_WrCoCmd_Buffer(phost,DISPLAY());
  Ft_Gpu_CoCmd_Swap(phost);
  Ft_App_Flush_Co_Buffer(phost);
  Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
  // Ftdi Logo animation
  Ft_Gpu_CoCmd_Logo(phost);
  Ft_App_Flush_Co_Buffer(phost);
  Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
  while(0!=Ft_Gpu_Hal_Rd16(phost,REG_CMD_READ)); 
  // copy the displaylsit to gram
  dloffset = Ft_Gpu_Hal_Rd16(phost,REG_CMD_DL);
  dloffset -=4;
  Ft_Gpu_Hal_WrCmd32(phost,CMD_MEMCPY);
  Ft_Gpu_Hal_WrCmd32(phost,100000L);
  Ft_Gpu_Hal_WrCmd32(phost,RAM_DL);
  Ft_Gpu_Hal_WrCmd32(phost,dloffset);
  play_setup();
  do
  {
    // start the new displaylist
      static PROGMEM prog_uint32_t std[] = {
     CMD_DLSTART,
     CMD_APPEND,100000L,448L,
     BITMAP_TRANSFORM_A(256),
     BITMAP_TRANSFORM_B(0),
     BITMAP_TRANSFORM_D(0),
     BITMAP_TRANSFORM_E(256),
     BITMAP_TRANSFORM_F(0),   
     SAVE_CONTEXT(),
     COLOR_RGB(219,180,150),
     COLOR_A(220),
     BEGIN(EDGE_STRIP_A),
   };MEMCMD(std);
    Ft_App_WrCoCmd_Buffer(phost,VERTEX2F(0,FT_DispHeight*16));
    Ft_App_WrCoCmd_Buffer(phost,VERTEX2F(FT_DispWidth*16,FT_DispHeight*16));
    Ft_App_WrCoCmd_Buffer(phost,COLOR_A(255));
    Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(0,0,0));
   // INFORMATION (char*)pgm_read_word(&info[
    Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,20,28,OPT_CENTERX|OPT_CENTERY,(char*)pgm_read_word(&info[0]));
    Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,60,26,OPT_CENTERX|OPT_CENTERY,(char*)pgm_read_word(&info[1]));
    Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,90,26,OPT_CENTERX|OPT_CENTERY,(char*)pgm_read_word(&info[2]));  
    Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,120,26,OPT_CENTERX|OPT_CENTERY,(char*)pgm_read_word(&info[3]));  
    Ft_Gpu_CoCmd_Text(phost,FT_DispWidth/2,FT_DispHeight-30,26,OPT_CENTERX|OPT_CENTERY,"Click to play");
    // check the play button
    if(sk!='P')
    Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
    else
    Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(100,100,100));
    Ft_App_WrCoCmd_Buffer(phost,BEGIN(FTPOINTS));   
    Ft_App_WrCoCmd_Buffer(phost,POINT_SIZE(20*16));
    Ft_App_WrCoCmd_Buffer(phost,TAG_MASK(1));
    Ft_App_WrCoCmd_Buffer(phost,TAG('P'));
    Ft_App_WrCoCmd_Buffer(phost,VERTEX2F((FT_DispWidth/2)*16,(FT_DispHeight-60)*16));
    Ft_App_WrCoCmd_Buffer(phost,TAG_MASK(0));
    Ft_App_WrCoCmd_Buffer(phost,COLOR_RGB(180,35,35));
    Ft_App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS));
    Ft_App_WrCoCmd_Buffer(phost,VERTEX2II((FT_DispWidth/2)-14,(FT_DispHeight-75),14,0));
    Ft_App_WrCoCmd_Buffer(phost,DISPLAY());
    Ft_Gpu_CoCmd_Swap(phost);
    Ft_App_Flush_Co_Buffer(phost);
    Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
  }while(Read_keys()!='P');
  Ft_Play_Sound(0x50,255,0xc0);
  /* Wait until the user enter the play button*/
}


static  ft_uint16_t xoff,yoff;

// Show the Calander in the format date\month\year 
void calender()
{
  xoff = (FT_DispWidth/2)-75;
  yoff = (FT_DispHeight)-(50);
  Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH(3*16));
  Ft_Gpu_Hal_Transfer32(phost,BEGIN(RECTS));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(xoff*16,yoff*16));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff+150)*16,(yoff+40)*16));
  Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB(0,0,0));
  Ft_Gpu_Hal_Transfer32(phost,TAG_MASK(1));
  Ft_Gpu_Hal_Transfer32(phost,TAG(CALENDER));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff+2)*16,(yoff+2)*16));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff+148)*16,(yoff+38)*16));
  Ft_Gpu_Hal_Transfer32(phost,TAG_MASK(0));
  Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB(255,255,255));
  Ft_Gpu_Hal_Transfer32(phost,BEGIN(BITMAPS));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2II((xoff+0),(yoff+2),3,0));
  xoff += 6;
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2II((xoff),(yoff+5),29,(Rtc.date/10)+'0'));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2II((xoff+13),(yoff+5),29,(Rtc.date%10)+'0'));      // width 14+2      //26
  xoff += 41 ;
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2II((xoff),(yoff+5),29,(Rtc.month/10)+'0'));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2II((xoff+13),(yoff+5),29,(Rtc.month%10)+'0'));      // width 14+2
  xoff += 39;
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2II((xoff),(yoff+5),29,2+'0'));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2II((xoff+13),(yoff+5),29,0 +'0'));      // width 14+2
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2II((xoff+26),(yoff+5),29,(Rtc.year/10)+'0'));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2II((xoff+39),(yoff+5),29,(Rtc.year%10)+'0'));      // width 14+2

  Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH(1*16));
  xoff = (FT_DispWidth/2)-75;
  yoff = (FT_DispHeight)-(50);

  Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB(100,100,100));
  Ft_Gpu_Hal_Transfer32(phost,BEGIN(LINES));
  xoff += 38;
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff)*16,(yoff+8)*16));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff)*16,(yoff+32)*16));      // width 14+2
  xoff += 42;
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff)*16,(yoff+8)*16));
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff)*16,(yoff+32)*16));      // width 14+2
}

// date setting screen

void Date_Setting(ft_uint8_t date,ft_uint8_t month,ft_uint8_t year)
{
    xoff = (FT_DispWidth/2)-75;
    yoff = (FT_DispHeight)-(50);
    Ft_Gpu_Hal_Transfer32(phost,COLOR_A(150));
    Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH(1*16));
    Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB(0,0,0));
    Ft_Gpu_Hal_Transfer32(phost,BEGIN(RECTS));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff-10)*16,25*16));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff+160)*16,155*16));
    Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB(255,255,255));
    Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH(4*16));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F(xoff*16,35*16));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff+150)*16,145*16));
    Ft_Gpu_Hal_Transfer32(phost,COLOR_A(255));
    Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB(0,0,0));
    Ft_Gpu_Hal_Transfer32(phost,LINE_WIDTH(1*16));
    Ft_Gpu_Hal_Transfer32(phost,BEGIN(LINES));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff+38)*16,38*16));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff+38)*16,142*16));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff+80)*16,38*16));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff+80)*16,142*16));
    Ft_Gpu_Hal_Transfer32(phost,BEGIN(BITMAPS));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+6,75,29,(date/10)+'0'));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+19,75,29,(date%10)+'0'));      // width 14+2      //26

    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II( xoff+47,75,29,(month/10)+'0'));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II( xoff+60,75,29,(month%10)+'0'));      // width 14+2
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II( xoff+90,75,29, 2+'0'));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II( xoff+103,75,29,0 +'0'));      // width 14+2
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+116,75,29,(year/10)+'0'));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+129,75,29,(year%10)+'0'));      // width 14+2
    Ft_Gpu_Hal_Transfer32(phost,TAG_MASK(1));
    Ft_Gpu_Hal_Transfer32(phost,TAG(DATE_INCR));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+3,45,13,0));      // width 14+2
    Ft_Gpu_Hal_Transfer32(phost,TAG(MONTH_INCR));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+44,45,13,0));      // width 14+2
    Ft_Gpu_Hal_Transfer32(phost,TAG(YEAR_INCR));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+100,45,13,0));      // width 14+2*/
    Ft_Gpu_Hal_Transfer32(phost,TAG(DATE_DEC));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+3,120,13,1));      // width 14+2
    Ft_Gpu_Hal_Transfer32(phost,TAG(MONTH_DEC));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+44,120,13,1));      // width 14+2
    Ft_Gpu_Hal_Transfer32(phost,TAG(YEAR_DEC));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+100,120,13,1));      // width 14+2*/
    Ft_Gpu_Hal_Transfer32(phost,TAG_MASK(0));
}
ft_void_t swissclock_init()
{
  ft_int32_t tval;
  {
    ft_uint8_t tempbuff[272];
  for(tval=0;tval<(FT_DispHeight/2);tval++)
  {
    tempbuff[FT_DispHeight-1-tval] = tempbuff[tval] = (tval*0.9);
  }
  Ft_Gpu_Hal_WrMem(phost,4096L,tempbuff,FT_DispHeight);
  
  for(tval=0;tval<40;tval++)
  {
    tempbuff[tval] = tval*0.65;
  }
  
  Ft_Gpu_Hal_WrMem(phost,4368L,tempbuff,40);
  for(tval=0;tval<177;tval++)
  {
    tempbuff[tval] = tval/3;
  }
  Ft_Gpu_Hal_WrMem(phost,4408L,tempbuff,177);
  }  
}
//========================================Application ==============================================
void Swissclock()
{
 ft_char8_t wall_index=0;
  ft_uint8_t clkbgindex=0, bmp_handle=0, key_in=0,r,g,b,
              Read_tag,temp_tag,Tag_pro,temp_date,temp_month,temp_year;
  ft_uint32_t  bgrgb,  minrgb,  secrgb;
  ft_uint16_t temp_clk_s=0,temp_clk_x=0, temp_clk_y=0, temp_img_w=0,  temp_img_h=0,
              temp_img_x=0, temp_img_y=0,tval,key_delay=0;


// Intial settings
 r = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+0]);
  g = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+1]);
  b = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+2]);
  bgrgb =  ((ft_uint32_t)r<<16) | ((ft_uint32_t)g<<8) | ((ft_uint32_t)b<<0);
  r = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+4]);
  g = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+5]);
  b = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+6]) ;
  minrgb =  ((ft_uint32_t)r<<16) | ((ft_uint32_t)g<<8) | ((ft_uint32_t)b<<0);
  
  r = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+8]);
  g = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+9]);
  b = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+10]) ;
  secrgb =  ((ft_uint32_t)r<<16) | ((ft_uint32_t)g<<8) | ((ft_uint32_t)b<<0);

  temp_clk_x = image_prp[wall_index].clk_orgin_x;
  temp_clk_y = image_prp[wall_index].clk_orgin_y;
  temp_img_w = image_prp[0].imw;
  temp_img_h = image_prp[0].imh;
  temp_clk_s = image_prp[wall_index].clk_size;
  temp_img_x = (FT_DispWidth - temp_img_w)/2;
  temp_img_y = 5; // for 0//(FT_DispHeight - temp_img_h)/2;

  wall_bg = 0;
  bmp_handle=0;
  wall_index =0;

// for gradient effect
  incdec_setup();
  swissclock_init();
  Init_Audio();
  Ft_DlBuffer_Index = 0;
  Ft_App_WrDlCmd_Buffer(phost,CLEAR(1,1,1));
  Ft_App_WrDlCmd_Buffer(phost,COLOR_A(255));
  Ft_App_WrDlCmd_Buffer(phost,COLOR_RGB(255,255,255));
  
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(2));
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(4096L));
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(L8,1,FT_DispHeight));
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST, REPEAT, BORDER, FT_DispWidth, FT_DispHeight));
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(5));
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(4408L));
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(L8,1,177));
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST, REPEAT, BORDER, 284L, 177));
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_HANDLE(3));
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_SOURCE(4368L));
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_LAYOUT(L8,1,40));
  Ft_App_WrDlCmd_Buffer(phost,BITMAP_SIZE(NEAREST, REPEAT, BORDER, 150, 40));
  Load_wallbg(bmp_handle);
  Ft_App_Flush_DL_Buffer(phost);
  Ft_Gpu_DLSwap(DLSWAP_FRAME);

//intilaize the tracker
  Ft_CmdBuffer_Index = 0;
  Ft_Gpu_CoCmd_Track(phost,temp_clk_x+temp_img_x,temp_clk_y+temp_img_y,1,1,CLOCK_MINTAG);
  Ft_App_Flush_Co_Buffer(phost);													//L8 format
  Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
// wait for j1 idle

  Flag.Load_image = 1;
  Flag.clk_adj = 0;
  timer();

  while(1)
  {
  // read the touch  
 //   Serial.println(millis()-curtime);
//   curtime = millis();
    
   if(0==Ft_Gpu_Hal_Rd8(phost,REG_DLSWAP))
   {
    Read_tag = Ft_Gpu_Hal_Rd8(phost,REG_TOUCH_TAG);
    if(Read_tag!=NULL && temp_tag!=Read_tag)
    {
        temp_tag = Read_tag;
        Flag.Touch_detect = 1;
    }
    if(Read_tag!=NULL && temp_tag==Read_tag)
    {
  // for time setting the faster increment and decrement    
      if(Read_tag > 4 && Read_tag < 11)
      {
          key_delay++;
         if(key_delay>10)
         {
            key_delay = 0;
            Flag.Touch_detect = 0;
            Tag_pro = Read_tag;
         }
      }
    }
  // Confirm the funtion to process  
    if(Read_tag==NULL)
    {
      key_delay = 0;
      if(Flag.Touch_detect==1 && temp_tag!=255)
      {
        if(!Flag.date_set)
        Ft_Play_Sound(0x50,100,0xc8);
        Tag_pro = temp_tag;
      }else
      {
        Tag_pro = 0;
      }
      Flag.Touch_detect = 0;
      temp_tag = 0;
    }
    if(Flag.rotary )  { Read_tag = 0;  Tag_pro = 0;}
    if(Flag.date_set) { Read_tag = 0;}
    
    // Key in functions
    switch(Tag_pro)
    {
      case CLOCK_BGTAG:
                      if(Flag.date_set==0)
                      {
                        clkbgindex++;
                        if(clkbgindex > MAX_CLOCK_PROP)clkbgindex = 0;
                        r = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+0]);
                        g = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+1]);
                        b = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+2]);
                        bgrgb =  ((ft_uint32_t)r<<16) | ((ft_uint32_t)g<<8) | ((ft_uint32_t)b<<0);
                        r = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+4]);
                        g = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+5]);
                        b = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+6]) ;
                        minrgb =  ((ft_uint32_t)r<<16) | ((ft_uint32_t)g<<8) | ((ft_uint32_t)b<<0);
                        
                        r = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+8]);
                        g = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+9]);
                        b = ft_pgm_read_byte(&clk_prp[(clkbgindex*12)+10]) ;
                        secrgb =  ((ft_uint32_t)r<<16) | ((ft_uint32_t)g<<8) | ((ft_uint32_t)b<<0);
                      }
      break;

      case WALL_BGTAG:
                     if(Flag.date_set==0)
                     {
                       if(Flag.img_change==0) Flag.img_change = 1;
                     }

      break;

      case CALENDER:
                      if(Flag.date_set==0)
                      {
                        Flag.date_set = 1;
                        temp_date = Rtc.date;
                        temp_month = Rtc.month;
                        temp_year = Rtc.year;
                      }
                      else
                      {
                        Ft_Play_Sound(0x50,100,0xc8);
                        Flag.date_set = 0;
                        Rtc.date = temp_date;
                        Rtc.month = temp_month;
                        Rtc.year = temp_year;
                        Rtc_puts();
                      }

      break;

      case DATE_INCR:
                    if(temp_date < 31) temp_date++;  else
                    temp_date = 1;
      break;

      case DATE_DEC:
                    if(temp_date > 1) temp_date--;  else
                    temp_date = 31;
      break;

      case MONTH_INCR:
                    if(temp_month < 12) temp_month++;  else
                    temp_month = 1;
      break;

      case MONTH_DEC:
                    if(temp_month > 1) temp_month--;  else
                    temp_month = 12;
      break;


      case YEAR_INCR:
                    if(temp_year < 99) temp_year++;  else
                    temp_year = 0;
      break;

      case YEAR_DEC:
                    if(temp_year > 0) temp_year--;  else
                    temp_year = 99;
      break;

      case AM_PM:
                    Flag.am_pm ^=1;
                    Rtc_puts();
      break;


    }
   // image loading and bitmap handling functions 
    if(Flag.img_change==1 && sd_present==0)
    {
      if(wall_index<1)wall_index++; else wall_index=0;
      Flag.img_change = 0;
    }
    if(Flag.img_change==1 &&  sd_present==1)
    {
     if(Flag.Image_loaded==1)
     {
        Flag.img_change = 0;
        Flag.Load_image = 1;
        if(wall_index<9)wall_index++; else wall_index=0;
        bmp_handle^=1;
        temp_clk_x = image_prp[wall_index].clk_orgin_x;
        temp_clk_y = image_prp[wall_index].clk_orgin_y;
        temp_clk_s = image_prp[wall_index].clk_size;
        temp_img_w = image_prp[wall_index].imw;
        temp_img_h = image_prp[wall_index].imh;
        temp_img_x = (FT_DispWidth - temp_img_w)/2;
        temp_img_y = (FT_DispHeight - temp_img_h)/2;
        if(wall_index==0 || wall_index==1)temp_img_y = 5;
        Ft_CmdBuffer_Index = 0;
        Ft_Gpu_CoCmd_Track(phost,temp_clk_x+temp_img_x,temp_clk_y+temp_img_y,1,1,CLOCK_MINTAG);
        Ft_App_Flush_Co_Buffer(phost);													//L8 format
        Ft_Gpu_Hal_WaitCmdfifo_empty(phost);
      }
    }

// Construct the display list in DLRAM
  Ft_DlBuffer_Index=0;
  Ft_App_WrDlCmd_Buffer(phost,CLEAR(1,1,1));
  Ft_App_WrDlCmd_Buffer(phost,COLOR_RGB(255,255,255));
  Ft_App_WrDlCmd_Buffer(phost,CLEAR_TAG(255));
  Ft_App_WrDlCmd_Buffer(phost,BEGIN(BITMAPS));
  Ft_App_WrDlCmd_Buffer(phost,VERTEX2II(0,0,2,0));
  Ft_App_WrDlCmd_Buffer(phost,LINE_WIDTH(1*16));
  Ft_App_WrDlCmd_Buffer(phost,BEGIN(RECTS));
  if(Flag.Load_image == 1 && sd_present==1)
  {
    Flag.Load_image = 0;
    Flag.Image_loaded = 0;
    Load_wallbg(bmp_handle^1);
  }
  
  Ft_Gpu_Hal_StartTransfer(phost,FT_GPU_WRITE,RAM_DL+Ft_DlBuffer_Index);
  
  if(Read_tag==WALL_BGTAG)
  {
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((ft_int16_t)(temp_img_x*0.999)*16,(ft_int16_t)(temp_img_y*0.999)*16));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((ft_int16_t)((temp_img_x+temp_img_w)/0.999)*16,(ft_int16_t)((temp_img_y+temp_img_h)/0.999)*16));
  }
  if(wall_index==0 || wall_index==1)
  {
    if(wall_index==0)Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB(0,0,0));
    if(wall_index==1)Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB(128,108,71));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((ft_int16_t)(temp_img_x)*16,(ft_int16_t)(temp_img_y)*16));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((ft_int16_t)((temp_img_x+temp_img_w-1))*16,(ft_int16_t)((temp_img_y+temp_img_h-1))*16));
    Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB(255,255,255));
  }
  Ft_Gpu_Hal_Transfer32(phost,BEGIN(BITMAPS));
  Ft_Gpu_Hal_Transfer32(phost,TAG(WALL_BGTAG));
  if(wall_index==0 || wall_index==1)
  Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(temp_img_x,temp_img_y,5,0));
  else Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(temp_img_x,temp_img_y,bmp_handle,0));
//  Serial.println(bmp_handle,DEC);
  Draw_Clock(temp_clk_x+temp_img_x,temp_clk_y+temp_img_y,(Read_tag == CLOCK_BGTAG) ? (temp_clk_s*1.06):(temp_clk_s*1),bgrgb,minrgb,secrgb);

  if(wall_index==0 || wall_index==1)
  {
    Ft_Gpu_Hal_Transfer32(phost,COLOR_RGB(255,255,255));
    xoff = (FT_DispWidth/2)-125;
    yoff = (FT_DispHeight)-(50);
    Ft_Gpu_Hal_Transfer32(phost,TAG_MASK(1));
    Ft_Gpu_Hal_Transfer32(phost,COLOR_MASK(0,0,0,0));
    Ft_Gpu_Hal_Transfer32(phost,BEGIN(RECTS));
    Ft_Gpu_Hal_Transfer32(phost,TAG(AM_PM));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff)*16,(yoff+20)*16));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2F((xoff+40)*16,(yoff+40)*16));
    Ft_Gpu_Hal_Transfer32(phost,COLOR_MASK(1,1,1,1));
    Ft_Gpu_Hal_Transfer32(phost,BEGIN(BITMAPS));
    if(Flag.am_pm==1)
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+5,yoff+25,26,'P'));
    if(Flag.am_pm==0)
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+5,yoff+25,26,'A'));
    Ft_Gpu_Hal_Transfer32(phost,VERTEX2II(xoff+14,yoff+25,26,'M'));
    calender();
    if(Flag.date_set==1)
    Date_Setting(temp_date,temp_month,temp_year);
  }
  Ft_Gpu_Hal_Transfer32(phost,DISPLAY());
  Ft_Gpu_Hal_EndTransfer(phost);
  //Ft_Gpu_Hal_Wr8(phost,REG_DLSWAP,DLSWAP_FRAME);
   Ft_Gpu_DLSwap(DLSWAP_FRAME);
  }
  if(Flag.Image_loaded==0 && Flag.audio_play==0 && sd_present==1)
  {
    Load_Jpeg();
  }
  timer();
  if(sd_present==1 && Flag.time_alert==1)  alert();
  }
}



#ifdef MSVC_PLATFORM
/* Main entry point */
ft_int32_t main(ft_int32_t argc,ft_char8_t *argv[])
#endif
#ifdef ARDUINO_PLATFORM
ft_void_t setup()
#endif
{
  /* Local variables */
  ft_uint8_t chipid;

  Ft_Gpu_HalInit_t halinit;

  halinit.TotalChannelNum = 1;
  Ft_Gpu_Hal_Init(&halinit);
  host.hal_config.channel_no = 0;
#ifdef MSVC_PLATFORM_SPI
  host.hal_config.spi_clockrate_khz = 12000; //in KHz
#endif
#ifdef ARDUINO_PLATFORM_SPI
  host.hal_config.spi_clockrate_khz = 4000; //in KHz
#endif
  Ft_Gpu_Hal_Open(&host);

  phost = &host;

  /* Do a power cycle for safer side */
  Ft_Gpu_Hal_Powercycle(phost,FT_TRUE);
  Ft_Gpu_Hal_Rd16(phost,RAM_G);
  /* Set the clk to external clock */
  Ft_Gpu_HostCommand(phost,FT_GPU_EXTERNAL_OSC);
  Ft_Gpu_Hal_Sleep(10);


  /* Switch PLL output to 48MHz */
  Ft_Gpu_HostCommand(phost,FT_GPU_PLL_48M);
  Ft_Gpu_Hal_Sleep(10);

  /* Do a core reset for safer side */
  Ft_Gpu_HostCommand(phost,FT_GPU_CORE_RESET);
  //Ft_Gpu_CoreReset(phost);

  /* Access address 0 to wake up the FT800 */
  Ft_Gpu_HostCommand(phost,FT_GPU_ACTIVE_M);

  {
    //Read Register ID to check if FT800 is ready.
    chipid = Ft_Gpu_Hal_Rd8(phost, REG_ID);
    while(chipid != 0x7C)
      chipid = Ft_Gpu_Hal_Rd8(phost, REG_ID);
#ifdef MSVC_PLATFORM
    printf("VC1 register ID after wake up %x\n",chipid);
#endif
  }
//Calibration for WQVA

  /* Configuration of LCD display */
#if 0// SAMAPP_DISPLAY_QVGA
  /* Values specific to QVGA LCD display */
  FT_DispWidth = 320;
  FT_DispHeight = 240;
  FT_DispHCycle =  408;
  FT_DispHOffset = 70;
  FT_DispHSync0 = 0;
  FT_DispHSync1 = 10;
  FT_DispVCycle = 263;
  FT_DispVOffset = 13;
  FT_DispVSync0 = 0;
  FT_DispVSync1 = 2;
  FT_DispPCLK = 8;
  FT_DispSwizzle = 2;
  FT_DispPCLKPol = 0;

#endif

  Ft_Gpu_Hal_Wr16(phost, REG_HCYCLE, FT_DispHCycle);
  Ft_Gpu_Hal_Wr16(phost, REG_HOFFSET, FT_DispHOffset);
  Ft_Gpu_Hal_Wr16(phost, REG_HSYNC0, FT_DispHSync0);
  Ft_Gpu_Hal_Wr16(phost, REG_HSYNC1, FT_DispHSync1);
  Ft_Gpu_Hal_Wr16(phost, REG_VCYCLE, FT_DispVCycle);
  Ft_Gpu_Hal_Wr16(phost, REG_VOFFSET, FT_DispVOffset);
  Ft_Gpu_Hal_Wr16(phost, REG_VSYNC0, FT_DispVSync0);
  Ft_Gpu_Hal_Wr16(phost, REG_VSYNC1, FT_DispVSync1);
  Ft_Gpu_Hal_Wr8(phost, REG_SWIZZLE, FT_DispSwizzle);
  Ft_Gpu_Hal_Wr8(phost, REG_PCLK_POL, FT_DispPCLKPol);
  Ft_Gpu_Hal_Wr8(phost, REG_PCLK,FT_DispPCLK);//after this display is visible on the LCD
  Ft_Gpu_Hal_Wr16(phost, REG_HSIZE, FT_DispWidth);
  Ft_Gpu_Hal_Wr16(phost, REG_VSIZE, FT_DispHeight);

  /* Initially fill both ping and pong buffer */
  Ft_Gpu_Hal_Wr8(phost, REG_GPIO_DIR,0xff);
  Ft_Gpu_Hal_Wr8(phost, REG_GPIO,0x0ff);
  /* Touch configuration - configure the resistance value to 1200 - this value is specific to customer requirement and derived by experiment */
  Ft_Gpu_Hal_Wr16(phost, REG_TOUCH_RZTHRESH,1200);



  /*It is optional to clear the screen here*/
  Ft_Gpu_Hal_WrMem(phost, RAM_DL,(ft_uint8_t *)FT_DLCODE_BOOTUP,sizeof(FT_DLCODE_BOOTUP));
  Ft_Gpu_Hal_Wr8(phost, REG_DLSWAP,DLSWAP_FRAME);

  //Ft_Gpu_Hal_Sleep(1000);//Show the booting up screen.


  pinMode(FT_SDCARD_CS,OUTPUT);
  digitalWrite(FT_SDCARD_CS,HIGH);
  delay(100);
  sd_present =  SD.begin(FT_SDCARD_CS);
  SPI.setClockDivider(SPI_CLOCK_DIV2);
  SPI.setBitOrder(MSBFIRST);
  SPI.setDataMode(SPI_MODE0);  
  #ifdef RTC_PRESENT
  hal_rtc_i2c_init();
  byte WriteByte = 0x03;
  hal_rtc_i2c_write(0x07, &WriteByte,1);
  hal_rtc_i2c_read(0x00, &WriteByte,1);
  if((WriteByte&0x80)==0)
  {
    WriteByte = 0x80;
    hal_rtc_i2c_write(0x00, &WriteByte,1);
  }
  #endif
  

  Info();
  Swissclock();
#ifdef MSVC_PLATFORM
  return 0;
#endif
}

void loop()
{
}



/* Nothing beyond this */



